"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _excluded = ["d"],
  _excluded2 = ["text"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var SvgRenderer = /*#__PURE__*/function () {
  function SvgRenderer() {
    _classCallCheck(this, SvgRenderer);
    this.paths = [];
    this.texts = [];
    this.circles = [];
    this.rects = [];
  }
  _createClass(SvgRenderer, [{
    key: "addObject",
    value: function addObject(obj) {
      for (var key in obj) {
        this[key] = this[key].concat(obj[key]);
      }
    }
  }, {
    key: "addRects",
    value: function addRects(arr) {
      this.addObject({
        rects: arr
      });
    }
  }, {
    key: "addTexts",
    value: function addTexts(arr) {
      this.addObject({
        texts: arr
      });
    }
  }, {
    key: "render",
    value: function render() {
      var svgElems = [];
      if (this.paths.length) {
        svgElems = svgElems.concat(this.paths.map(function (data, i) {
          if (_typeof(data) === "object") {
            var _data = _objectSpread({}, data),
              d = _data.d,
              props = _objectWithoutProperties(_data, _excluded);
            return /*#__PURE__*/_react["default"].createElement("path", _extends({
              key: "p".concat(i),
              d: d
            }, props));
          }
          return /*#__PURE__*/_react["default"].createElement("path", {
            key: "p".concat(i),
            d: data,
            stroke: "black",
            strokeWidth: "1px"
          });
        }));
      }
      if (this.texts.length) {
        svgElems = svgElems.concat(this.texts.map(function (props, i) {
          var text;
          var _props = props;
          text = _props.text;
          props = _objectWithoutProperties(_props, _excluded2);
          _props;
          return /*#__PURE__*/_react["default"].createElement("text", _extends({
            key: "t".concat(i)
          }, props), text);
        }));
      }
      if (this.circles.length) svgElems = svgElems.concat(this.circles.map(function (props, i) {
        return /*#__PURE__*/_react["default"].createElement("circle", _extends({
          key: "c".concat(i)
        }, props));
      }));
      if (this.rects.length) {
        svgElems = svgElems.concat(this.rects.map(function (props, i) {
          return /*#__PURE__*/_react["default"].createElement("rect", _extends({
            key: "r".concat(i)
          }, props));
        }));
      }
      return svgElems;
    }
  }]);
  return SvgRenderer;
}();
var _default = SvgRenderer;
exports["default"] = _default;