"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var BarView = /*#__PURE__*/function () {
  function BarView() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    _classCallCheck(this, BarView);
    var DEFAULT_WIDTH = 750;
    var DEFAULT_BARS_PER_LINE = 4;
    var DEFAULT_MARGINS = {
      top: 20,
      left: 20,
      line: 30,
      right: 20,
      bottom: 20
    };
    var DEFAULT_BAR_DIMENSIONS = {
      padding: {
        top: 25,
        left: 8
      },
      height: 40,
      repetitionLineSpace: 4
    };
    this.barsPerLine = props.barsPerLine || DEFAULT_BARS_PER_LINE;
    this.margins = _objectSpread(_objectSpread({}, DEFAULT_MARGINS), props.margins);
    this.bar = _objectSpread(_objectSpread({}, DEFAULT_BAR_DIMENSIONS), props.bar);
    var width = props.width || DEFAULT_WIDTH;
    this.bar.width = (width - this.margins.left - this.margins.right) / this.barsPerLine;
  }
  _createClass(BarView, [{
    key: "getDimensions",
    value: function getDimensions(numBar) {
      if (numBar == null) {
        throw new TypeError("numBar argument must be a number");
      }
      var posBar = numBar % this.barsPerLine; // bar position
      var line = Math.floor(numBar / this.barsPerLine); // lineNumber
      var x = this.margins.left + this.bar.width * posBar;
      var y = this.margins.top + (this.bar.height + this.margins.line) * line;
      return [x, y];
    }
  }, {
    key: "setDimensions",
    value: function setDimensions(bar, numBar) {
      var _this$getDimensions = this.getDimensions(numBar),
        _this$getDimensions2 = _slicedToArray(_this$getDimensions, 2),
        x = _this$getDimensions2[0],
        y = _this$getDimensions2[1];
      bar.dimensions = {
        x: x,
        y: y
      };
      return bar;
    }
  }, {
    key: "getDivisor",
    value: function getDivisor(timeSig, duration) {
      var divisor;
      if (timeSig == "34") divisor = duration === "whole" ? 1 : 2;else divisor = duration === "quarter" ? 4 : duration === "half" ? 2 : 1;
      return divisor;
    }
  }, {
    key: "getStartXList",
    value: function getStartXList(timeSig, durations) {
      var _this = this;
      if (!Array.isArray(durations)) {
        throw new TypeError("durations should be an array");
      }
      var widthList = durations.map(function (duration) {
        return (_this.bar.width - _this.bar.padding.left) / _this.getDivisor(timeSig, duration);
      });
      var currentX = this.bar.padding.left;
      var startXList = [currentX];

      // until length - 1 because don't care about last width, getting starting points
      for (var i = 0; i < widthList.length - 1; i++) {
        currentX += widthList[i];
        startXList.push(currentX);
      }
      return startXList;
    }
  }, {
    key: "getHeight",
    value: function getHeight(totalBars) {
      if (totalBars == null) {
        throw new TypeError("totalBars should be a number");
      }
      return Math.ceil(totalBars / this.barsPerLine) * (this.bar.height + this.margins.line) + this.margins.bottom;
    }
  }]);
  return BarView;
}();
var _default = BarView;
exports["default"] = _default;